// name: Sound Driver for jBOS
// author: Nathaniel van Diepen
// version: 1.0
// description: Allows for playing sounds
;(function($){	
	$.extend({
		// sound specific functions
		sound:{
			//plays a sound and deletes the object after it has been played
			play: function(path){
				if(!document.getElementById($.system.md5('sound')))
					$.sound.init();
				if(path)
					path = $.file.pathFix(path);
				else
					path = document.getElementById($.system.md5('sound')).src;
				document.getElementById($.system.md5('sound')).src = path;
				try{
					document.getElementById($.system.md5('sound')).Play();
				}catch(e){
					try{
						document.getElementById($.system.md5('sound')).DoPlay();
					}catch(e){
						$.system.info('Sound not supported');
					}
				}
			},
			// Sets up the document to play a sound
			init: function(){
				if(!document.getElementById($.system.md5('sound'))){
					var sound = document.createElement('embed');
					sound.id = $.system.md5('sound');
					sound.autostart = false;
					sound.width = 0;
					sound.height = 0;
					sound.enablejavascript = true;
					sound.hidden = true;
					document.body.appendChild(sound);
					$.system.alert('Sound driver initialized');
				}else
					$.system.alert('Sound already initialized');
			},
			// turns off the ability to play sound
			disable: function(){
				document.body.removeChild(document.getElementById($.system.md5('sound')));
				$.system.alert('Sound driver disabled');
			}
		}
	});
})(jQuery);