// name: Window Driver for jBOS
// author: Nathaniel van Diepen
// version: 1.0
// description: Window manipulation functions that are not included in jDesktop
;(function($){	
	$.extend({
		// window specific functions
		window:{
			//change or return the width of the window
			width: function(id,value){
				var own = $("#"+id);
				if(!value)
					return $("#"+id+' div.container').width();
				else
					$("#"+id).width(value);
				return true;
			},
			//change or return the height of the window
			height: function(id,value){
				var own = $("#"+id);
				if(!value)
					return $("#"+id+' div.container').height();
				else
					$("#"+id).height(value);
				return true;
			},
			// change or return the title of the specified window
			title: function(id,value){
				if(value)
					return $('#'+id+' .wintitle .titletext').html(value);
				else
					return $('#'+id+' .wintitle .titletext').html();
			},
			// returns or sets the html of the window's container
			html: function(id,value){
				if(value)
					return $("#"+id).find('div.container').html(value);
				else
					return $("#"+id).find('div.container').html();
			},
			// returns the container for the specified window container
			container: function(id){
				return $("#"+id).find('div.container');
			},
			// sets the window themes
			theme: function(theme){
				$.settings.theme = theme;
				$('#main').fadeTo("slow",0,function(){
					jDesktop.ChangeSkin(theme);
					$('#main').fadeTo("slow",100);
				});
			}
		}
	});
})(jQuery);